import java.util.*;
import com.holub.tools.Subscriber;
import com.holub.tools.Multicaster;

public class Multicast_publisher
{
	Subscriber subscription_list; // = null

	public void subscribe( Subscriber subscriber )
	{	subscription_list =
						Multicaster.add( subscription_list, subscriber);
	}

	public void cancel_subscription( Subscriber subscriber )
	{	subscription_list =
					Multicaster.remove( subscription_list, subscriber );
	}

	public void publish()
	{	
		new Thread()
		{	public void run()
			{	if( subscription_list != null )	
					subscription_list.receive( "Hello world" );
			}
		}.start();
	}

	public void publish_sequentially()
	{
		new Thread()
		{	public void run()
			{	synchronized( subscription_list )
				{	if( subscription_list != null )	
						subscription_list.receive( "Hello world" );
				}
			}
		}.start();
	}
	//==================================================================
	public static class Test
	{	
		static private Multicast_publisher publisher  =
												new Multicast_publisher();

		static private Subscriber subscriber = 
								new Subscriber()
								{	public void receive(Object p)
									{	System.out.println( (String) p );
									}
								};

		static public void main( String[] args )
		{	publisher.subscribe( subscriber );
			publisher.publish();			// Publish "Hello world" events
		}
	}
}
