package com.holub.tools;

/**
 *	The interface implemented by subscribers to a "multicaster"
 *	In the Multicaster model, a "publisher" can also be a "subscriber,"
 *	so the Subscriber interface extends EventListener to give you
 *	some flexibility. This way the top-level publisher can choose
 *	to "be" a Subsriber (i.e. implement Subscriber) or to "use" a
 *	Subscriber (i.e. contain a reference to a Multicaster, which is
 *	a Subscriber).
 *
 *  @see Multicaster
 */

public interface Subscriber
{
	/**
	 *	The receive message is sent by the publisher (which either "is"
	 *	or "uses" a Multicaster) to all subscribers.
	 *	@param publication An object sent to the subscribers to give
	 *			them information about what happened.
	 */

	void receive( Object publication );
}
